/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * high speed patched by 씎Y(oo), HGG00736@niftyserve.or.jp
 */

/* System headers */
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdarg.h>
#include <sys/xstdio.h>
#include "sys/xstdlib.h"

#ifdef	ALL_FPUTC
#define	FPUTC	fputc
#else	/*!ALL_FPUTC*/
#define	FPUTC	putc
#endif	/*!ALL_FPUTC*/

/*
** {֐͑S C locale OƂăvO~OĂB
** ̎dlł͂ȊÕP[ɑΉ鎖͂Ȃ̂ɂ
** ƎvB
*/

/*
** dl --- ݂̂ƂAgcc  long double T|[gĂȂ̂
**	    libc ̓ł؂ɂĂ͍lĂȂB
*/

/* Macros */
#define DEFAULT_PRECISION 6	/* ftHg̕\x */
#define TMPBUFSIZ 512		/* ftHg̕ϊobt@̃TCY */

#define	/*int*/_m_isdigit(/*int*/c)	\
((unsigned char)((c)-'0')<=(unsigned char)('9'-'0'))

#define	/*int*/_m_ismbblead(/*int*/c)	\
( (unsigned char)((c)-0x81)<(unsigned char)(0xa0-0x81)\
||(unsigned char)((c)-0xe0)<(unsigned char)(0xfd-0xe0))

/* Macros */
#define UPPER_CHARSET "0123456789ABCDEF" /* 啶 */
#define LOWER_CHARSET "0123456789abcdef" /*  */

/* Macros */
#define _P_SHRTINT  0x001	/* short integer [h */
#define _P_LONGINT  0x002	/* long integer [h */
#define _P_LLNGINT  0x004	/* long long integer [h */
#define _P_LONGDBL  0x008	/* long double [h */
#define _P_SHARPEXT 0x010	/* # gtH[}bg̃[h */
#define _P_RUGLEFT  0x020	/* l߃[h */
#define _P_ZEROPAD  0x040	/* [l߃[h */
#define _P_LHEXPFIX 0x080	/* 16ivtBNX */
#define _P_UHEXPFIX 0x100	/* 啶16ivtBNX */
#define _P_OCTAPFIX 0x200	/* 8ivtBNX */
#define _P_BINAPFIX 0x400	/* 2ivtBNX */
#define _P_STROUT   0x800	/* o */

/* Macros */
#define DEDIGIT(x) ((x) - '0')
#define ENDIGIT(x) ((x) + '0')

/* File scope functions */
static char *format_L (unsigned long long uval, int flag,
		       int precision, int base, int *size, char *charset)
{
	char *ptr;
	unsigned int shift, mask;
	static char buffer[64];

	/* precision == 0 ȂΕϊȂ */
	if (precision == 0) {
		*size = 0;
		return buffer;
	}

	shift = mask = 0;
	ptr = buffer + sizeof buffer;

	/* `FbN(switch ̓TCY傫Ȃ) */
	switch (base) {
	case  2:	shift = 1;	mask = 1;	break;
	case  8:	shift = 3;	mask = 7;	break;
	case 16:
		/* {x */
		if (flag & _P_LLNGINT) {
			ptr = _ulltoha(charset, buffer, &uval);
			*size = ptr - buffer;
			return buffer;
		}
		else {
			shift = 4, mask = 15;
		}
		break;
	case 10:
	default:
		/* {x */
		if (flag & _P_LLNGINT) {
			ptr = _ulltoda(buffer, uval);
		}
		else {
			ptr = _ultoda(buffer, (unsigned long)uval);
		}
		*size = ptr - buffer;
		return buffer;
	}

	if (shift > 0) {
		/* 2, 8 iϊ */
		/* {x */
		if (flag & _P_LLNGINT) {
			ptr = _ulltoxa(ptr, shift, mask, charset, uval);
		}
		else {
			unsigned long uvals;

			uvals = (unsigned long) uval;
			do {
				*--ptr = charset[uvals & mask];
			} while (uvals >>= shift);
		}

		/* ϊ̃TCYݒ */
		*size = buffer + sizeof buffer - ptr;
	}

	/* ̐擪AhXԂ */
	return ptr;
}

static char *format_F (double dval, int precision,
		       int flag, int *gmode, int *size, char *buffer)
{
    char *t, *p;
    int sign, decimal;
    int dot;

    /* ftHg̐x̗p */
    if (precision == -1)
	precision = DEFAULT_PRECISION;

    /* fcvt pĕɕϊ */
    t = buffer;
    p = _fcvt (dval, precision, &decimal, &sign);
    dot = 0;

    /* Rs[ */
    if (decimal > 0) {
	while (decimal-- > 0)
	    *t++ = *p++;
	decimal++;
    }
    else {
	*t++ = '0';
    }

    /* xw肪邩 # g[hȂΏ_\ */
    if (precision > 0 || (flag & _P_SHARPEXT)) {
	*t++ = '.';
	dot = 1;
    }

    /* Rs[ */
    while (precision-- > 0) {
	if ((*t++ = *p++) == 0) {
	    precision++;
	    break;
	}
    }

    /* x */
    while (precision-- > 0)
	*t++ = '0';

    /* g-format  # g[hłȂ΍Ō̃[͎菜 */
    if (dot && gmode && (flag & _P_SHARPEXT) == 0) {
	for (*gmode = 0; t > buffer && *--t == '0'; (*gmode)++);
	if (*t == (unsigned char)'.') t--;
	t++;
    }

    /* TCYvZ */
    *size = t - buffer;

    /* ϊꂽւ̃|C^Ԃ */
    return buffer;
}

/* File scope functions */
static char *format_E (double dval, int precision,
		       int flag, int *gmode, int *size, int fmtch, char *buffer)
{
    char *t, *p;
    char *ptr;
    int dsize, exponent;
    int sign, decimal;

    /* ftHg̐x̗p */
    if (precision == -1)
	precision = DEFAULT_PRECISION;

    /* ecvt pĕɕϊ */
    t = buffer;
    p = _ecvt (dval, precision + 1, &decimal, &sign);
    exponent = decimal - 1;

    /* Rs[ */
    *t++ = *p++;

    /* xw肪邩 # g[hȂΏ_Rs[ */
    if (precision > 0 || (flag & _P_SHARPEXT))
      *t++ = '.';

    /* Rs[ */
    while (precision-- > 0) {
	if ((*t++ = *p++) == 0) {
	    precision++;
	    break;
	}
    }

    /* x */
    while (precision-- > 0)
	*t++ = '0';

    /* g-format  # g[hłȂ΍Ō̃[͎菜 */
    if (gmode && (flag & _P_SHARPEXT) == 0) {
	for (*gmode = 0; t > buffer && *--t == '0'; (*gmode)++);
	if (*t == (unsigned char)'.') t--;
	t++;
    }

    /* w}[Nݒ肷 */
    *t++ = fmtch;

    /* w̕ݒ肷 */
    if (exponent < 0) {
	exponent = -exponent;
	*t++ = '-';
    }
    else {
	*t++ = '+';
    }

    /* w̐Βl 10 Ȃ΃[擪ɉ */
    if (exponent < 10)
	*t++ = '0';

    /* w𐶐 */
    ptr = format_L (exponent, flag, -1, 10, &dsize, LOWER_CHARSET);

    /* A */
    while (dsize-- > 0)
	*t++ = *ptr++;

    /* ŏIIȃTCYvZ */
    *size = t - buffer;

    /* ϊւ̃AhXԂ */
    return buffer;
}

/* File scope functions */
static char *format_G (double dval, int *precisionp,
		       int flag, int *size, int fmtch, char *buffer)
{
    char *p;
    char *ptr;
    int exponent;
    int sign, decimal;
    int precision = *precisionp;
    int zerosup = 0;

    /* ftHg̐x̗p */
    if (precision == -1)
	precision = DEFAULT_PRECISION;

    /* w߂ */
    p = _ecvt (dval, precision, &decimal, &sign);
    exponent = decimal - 1;

    /* f-format  e-format ̂ǂɂ邩I */
    if ((exponent >= -4 && exponent < precision) || precision == 0) {
	if (precision != 0)
	    precision -= exponent + 1;
	ptr = format_F (dval, precision, flag, &zerosup, size, buffer);
    }
    else {
	if (precision >= 1) precision--;
	fmtch -= 2;
	ptr = format_E (dval, precision, flag, &zerosup, size, fmtch, buffer);
    }

    /* [TvXɂĐxꍇ̕ω𔽉f */
    if (zerosup > 0)
	*precisionp -= zerosup;

    /* ϊւ̃AhXԂ */
    return buffer;
}

/* File scope functions */
static int format_last (FILE *fp, char *ptr, int flag,
			int sign, int width, int precision, int bodysize)
{
    int n, real_size;
    int string_size;

    /* ̒𒲐 */
    string_size = (bodysize
		   + ((sign) ? 1 : 0)
		   + ((flag & _P_OCTAPFIX) ? 1 : 0)
		   + ((flag & (_P_LHEXPFIX | _P_UHEXPFIX | _P_BINAPFIX)) ? 2 : 0));

    /* xĒ𒲐 */
    real_size = (precision > string_size) ? precision : string_size;

    /* 1. El߂̂߂̋󔒂o͂ */
    if ((flag & (_P_RUGLEFT | _P_ZEROPAD)) == 0)
	for (n = real_size; n < width; n++)
	    FPUTC(' ', fp);

    /* 2. o */
    if (sign)
	FPUTC(sign, fp);

    /* 2. 邢2i8i16ivtBNX */
    else if (flag & (_P_OCTAPFIX | _P_LHEXPFIX | _P_UHEXPFIX | _P_BINAPFIX)) {
	FPUTC('0', fp);
	if (flag & _P_LHEXPFIX)
	    FPUTC('x', fp);
	else if (flag & _P_UHEXPFIX)
	    FPUTC('X', fp);
	else if (flag & _P_BINAPFIX)
	    FPUTC('b', fp);
    }

    /* 3. El߂̂߂Ƀ[l߂sȂ */
    if ((flag & (_P_RUGLEFT | _P_ZEROPAD)) == _P_ZEROPAD)
	for (n = real_size; n < width; n++)
	    FPUTC('0', fp);

    /* 4. xp̃[l߂sȂ */
    for (n = string_size; n < precision; n++)
	FPUTC('0', fp);

    /* 5. lA邢͕{̂o͂ */
    if (flag & _P_STROUT) {
		int c;

		for (n = bodysize; --n >= 0; ) {
			c = *ptr++;
			if (_m_ismbblead(c)) {
				if (n--) {
					fputc(c, fp);
					c = *ptr++;
				}
				else {
					c = ' ';
				}
			}
			fputc(c, fp);
		}
    }
    else {
    for (n = bodysize; n > 0; --n)
	FPUTC(*ptr++, fp);
    }

    /* 6. lߗp̋󔒒sȂ */
    if (flag & _P_RUGLEFT)
	for (n = real_size; ++n <= width; )
	    FPUTC(' ', fp);

    /* o͕Ԃ */
    return (width > real_size) ? width : real_size;
}

/* Functions */
int _doprnt (const char *format, va_list ap, FILE *fp)
{
    char buf;					/* %c pobt@ */
    char *ptr, *tmp;				/* e|̃|C^ */
    char* charset;
    int base;
    int ch;					/* e|̕ */
    int count;					/* o͕ */
    int flag;					/* \[htO */
    int n;					/* e|̐l */
    int precision;				/* \x */
    int sign;					/*  */
    int size;					/* ̒ */
    int width;					/* tB[h */
    double dval;				/* _̒l */
    long long lval;				/* ̒l */
    const char *fmt;				/* tH[}bg͗p */
    char tmpbuf[TMPBUFSIZ];			/* 񏈗obt@ */

#define GETARG() \
    ((flag & _P_LLNGINT) ? va_arg (ap, long long) : \
     (flag & _P_SHRTINT) ? va_arg (ap, short) : va_arg (ap, int))

#define UGETARG() \
    ((flag & _P_LLNGINT) ? va_arg (ap, unsigned long long) : \
     (flag & _P_SHRTINT) ? va_arg (ap, unsigned short) : va_arg (ap, unsigned int))

    /* tH[}bg͂ */
    for (fmt = format, count = 0;; fmt++) {

	/* ʂ̓̕oCpX */
	while ((ch = *(unsigned char*)fmt++) && ((unsigned char)ch != '%')) {
#ifdef	ALL_FPUTC
	    fputc (ch, fp);
#else	/*!ALL_FPUTC*/
	    ((unsigned char)ch == '\n' ? fputc(ch, fp) : putc(ch, fp));
#endif
	    count++;
	}

	/*  */
	fmt--;

	/* null ɓBȂAI */
	if ((unsigned char)ch == '\0')
	    return feof (fp) ? EOF : count;

	/* parser p̃tO */
	flag = 0;
	width = 0;
	precision = -1;
	sign = '\0';
	charset = LOWER_CHARSET;

    loop:

	/* ̕o */
	if ((ch = *++fmt) == '\0')
	    return feof (fp) ? EOF : count;

	switch (ch) {

	/*
	 * ̃tH[}bǵA\[hw肷....
	 */

	case ' ':
	    /* space [h + [h override łȂ */
	    if ((unsigned char)sign == '\0') sign = ' ';
	    goto loop;
	case '#':
	    /* # g\[h */
	    flag |= _P_SHARPEXT;
	    goto loop;
	case '-':
	    /* l߃[h */
	    flag |= _P_RUGLEFT;
	    goto loop;
	case '+':
	    /* + [h space [h override ł */
	    sign = '+';
	    goto loop;
	case '0':
	    /* [l߃[h */
	    if ((unsigned char)sign != '-' && precision <= 0) flag |= _P_ZEROPAD;
	    goto loop;
	case 'h':
	    /*  short integer ł */
	    flag |= _P_SHRTINT;
	    goto loop;
	case 'l':
	    /*  long int ł */
	    flag |= _P_LONGINT;
	    goto loop;
	case 'L':
	    /*  long long int 邢 long double ł */
	    flag |= _P_LLNGINT | _P_LONGDBL;
	    goto loop;

	/*
	 * ̃tH[}bg͐xwł....
	 */

	case '.':
	    if ((ch = *++fmt) == (unsigned char)'*') {
		n = va_arg (ap, int);
	    }
	    else {
		n = 0;
		while (_m_isdigit (ch)) {
		    n = 10 * n + DEDIGIT (ch);
		    ch = *++fmt;
		}
		fmt--;
	    }
	    precision = n;
	    goto loop;

	/*
	 * ̃tH[}bg̓tB[h̎wł....
	 */

	case '*':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	    if ((ch = *fmt) == (unsigned char)'*') {
		if ((width = va_arg (ap, int)) < 0) {
		    width = -width;
		    flag |= _P_RUGLEFT;
		}
	    }
	    else {
		n = 0;
		do {
		    n = 10 * n + DEDIGIT (ch);
		    ch = *++fmt;
		} while (_m_isdigit (ch));
		width = n;
		fmt--;
	    }
	    goto loop;

	/*
	 * ̃tH[}bg͒lo߂̂̂ł
	 */

	case 'n':
	    if (flag & _P_LLNGINT)
		*va_arg (ap, long long*) = (long long) count;
	    else if (flag & _P_LONGINT)
		*va_arg (ap, long *) = (long) count;
	    else if (flag & _P_SHRTINT)
		*va_arg (ap, short *) = (short) count;
	    else
		*va_arg (ap, int *) = (int) count;
	    break;

	/*
	 * \....
	 */

	case 'c':
	    buf = (char) va_arg (ap, int);
	    if ((unsigned char)buf == '\n')
		flag |= _P_STROUT;
	    count += format_last (fp, &buf, flag, '\0', width, precision, 1);
	    break;

	/*
	 * 16iA8i\... yу|C^`
	 */

	case 'X':
	    charset = UPPER_CHARSET;
	    base = 16;
	    if (flag & _P_SHARPEXT) flag |= _P_UHEXPFIX;
	    goto uintout;

	case 'p':
	    if (precision == -1)
		precision = 8;

	case 'x':
	    base = 16;
	    if (flag & _P_SHARPEXT) flag |= _P_LHEXPFIX;
	    goto uintout;

	case 'o':
	    base = 8;
	    if (flag & _P_SHARPEXT) flag |= _P_OCTAPFIX;
	    goto uintout;

	case 'b':
	    base = 2;
	    if (flag & _P_SHARPEXT) flag |= _P_BINAPFIX;
	    goto uintout;

	/*
	 * \....
	 */

	case 'Z':
	case 'U':
	    flag |= _P_LONGINT;
	case 'u':
	    base = 10;
	uintout:
	    if (((unsigned long long)lval = UGETARG ()) == 0)
		flag &= ~(_P_UHEXPFIX|_P_LHEXPFIX|_P_OCTAPFIX|_P_BINAPFIX);
	    sign = '\0';
	    goto intout;

	case 'D':
	case 'I':
	    flag |= _P_LONGINT;
	case 'd':
	case 'i':
	    base = 10;
	    if ((lval = GETARG ()) < 0) {
		lval = -lval;
		sign = '-';
	    }
	intout:
	    ptr = format_L (lval, flag, precision, base, &size, charset);
	    count += format_last (fp, ptr, flag, sign, width, precision, size);
	    break;

	/*
	 * \....
	 */

	case 's':
	    /* k|C^`FbN */
	    if ((ptr = va_arg (ap, char *)) == 0)
		ptr = "(null)";
	    else
		flag |= _P_STROUT;

	strout:
	    /* \xATCY */
	    size = (precision < 0) ? strlen (ptr) :
		(tmp = memchr (ptr, '\0', precision)) ? tmp - ptr : precision;

	    /* o */
	    count += format_last (fp, ptr, flag, '\0', width, size, size);
	    break;

	/*
	 * _\....
	 */

	case 'f':
	case 'g':
	case 'G':
	case 'e':
	case 'E':

	    /* o */
	    dval = va_arg (ap, double);
	    if (((unsigned char*)&dval)[0] & 0x80) {
		((unsigned char*)&dval)[0] ^= 0x80;
		sign = '-';
	    }

	    /*  (NaN)  (inf) `FbN */
	    if (isnan (dval)) {
		ptr = "(NaN)";
		precision = -1;
		goto strout;
	    }
	    if (isinf (dval)) {
		ptr = "(Infinity)";
		precision = -1;
		goto strout;
	    }

	    /* ɕϊ */
	    if (*fmt == 'f')
		ptr = format_F (dval, precision, flag, 0, &size, tmpbuf);
	    else if (*fmt == 'e' || *fmt == 'E')
		ptr = format_E (dval, precision, flag, 0, &size, *fmt, tmpbuf);
	    else
		ptr = format_G (dval, &precision, flag, &size, *fmt, tmpbuf);

	    /* o */
	    count += format_last (fp, ptr, flag, sign, width, precision, size);
	    break;

	/*
	 * ȊO....
	 */

	default:
#ifdef	ALL_FPUTC
	    fputc (*fmt, fp);
#else	/*!ALL_FPUTC*/
	    (*(unsigned char*)fmt == '\n' ? fputc(*fmt, fp) : putc(*fmt, fp));
#endif	/*ALL_FPUTC*/
	    count++;
	    break;
	}
    }
}
