/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * long long patched by 씎Y(oo), HGG00736@niftyserve.or.jp
 */

/* System headers */
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/xstdio.h>

/*
** {֐͑S C locale OƂăvO~OĂB
** ̎dlł͂ȊÕP[ɑΉ鎖͂Ȃ̂ɂ
** ƎvB
*/

/*
** dl --- ݂̂ƂAgcc  long double T|[gĂȂ̂
**	    libc ̓ł؂ɂĂ͍lĂȂB
*/

/* Macros */
#define _P_SHRTINT  0x001	/* short integer [h */
#define _P_LONGINT  0x002	/* long integer [h */
#define _P_LLNGINT  0x004	/* long long integer [h */
#define _P_NDOUBLE  0x008	/* double [h */
#define _P_LONGDBL  0x010	/* long double [h */
#define _P_UNSIGND  0x020	/* unsigned [h */
#define _P_NOSTORE  0x040	/* l荞܂Ȃ */

/*
** ȉŎs EOF `FbN܂肨ȂĂȂAʓIɎs
** ̂ővƎvB
*/

/* Macros */
#define DEDIGIT(x) ((x) - '0')
#define ENDIGIT(x) ((x) + '0')

#define	/*int*/_m_isdigit(/*int*/c)	\
((unsigned char)((c)-'0')<=(unsigned char)('9'-'0'))
#define	/*int*/_m_isspace(/*int*/c)	\
((unsigned char)(c)==(unsigned char)' '||(unsigned char)((c)-'\t')<=(unsigned char)('\r'-'\t'))

/* Functions */
static int scanchr (unsigned char *pat, int c, size_t rest)
{
    int p, q;					/* p^ (p ͐擪Aq ͖) */

    /* p^[ */
    while (rest--) {

	/* p^񂩂ꕶo */
	p = *pat++;

	/* Ō܂ł܂ 2 ȏ゠A̕ `-' łȂ當 */
	/* ͈̔͂w肵Ă */
	if (rest >= 2 && *pat == '-') {

	    /* ͈͂̏I[o */
	    q = pat[1];

	    /* Ô߁AǂׁA͈͂`FbN */
	    if (p < q) {
		if (p <= c && c <= q)
		    return 1;
	    }

	    /* ̋tȂ.. */
	    else {
		if (q <= c && c <= p)
		    return 1;
	    }

	    /* }b`Ȃ̂ŁA|C^i߂ă`FbNp */
	    pat += 2;
	    rest -= 2;

	}
	else {

	    /* ʏ̏ꍇŁAvĂ 1 Ԃ */
	    if (p == c)
		return 1;

	}

    }

    /* p^Ƀ}b`Ȃ */
    return 0;
}

/* Functions */
int_ _doscan (const char *format, va_list ap, FILE *fp)
{
    int ch;					/* tH[}bgo */
    int got;					/* Xg[o */
    int nmatch;					/* }b`ڐ */
    int exflag;					/* otO */
    int fwidth;					/* tB[h */
    int n;					/* e| */
    int base;					/*  */
    int readed;					/* ǂݍ񂾃oCg */
    int cmlen;					/* `FbNpCfbNX */
    int gotdig;					/* l𓾂ǂ̃tO */
    int reverse;				/* ^ tO */
    int eof;					/* EOF tO */
    char *ptr;					/* e||C^ */
    char *stb;					/* e||C^ */
    char buffer[512];				/* ϊpobt@ */
    double dval;				/* double Ŏ󂯂鎞 */
    long val;					/* signed Ŏ󂯂Ƃ */
    unsigned long uval;				/* unsigned Ŏ󂯂鎞 */
    unsigned char *end;				/* [] Zbg̍Ō̈ʒu */
    unsigned char *scanp;			/* scanning |C^ */
    static char m[] = "0123456789abcdefABCDEF";	/* `FbNpz */

    extern long long strtoll(const char*, char**, int);
    extern unsigned long long strtoull(const char*, char**, int);

#define FGETC(p) \
    (readed++, fgetc (p))
#define UNGETC(c, p) \
    (readed--, ungetc ((c), (p)))

    /* JE^NA */
    nmatch = 0;
    readed = 0;
    eof = 0;
    scanp = (unsigned char *) format;

    /* tH[}bg */
    while (ch = *scanp++) {

	/* % Ȃ΃tH[}bg */
	if (ch == '%') {

	    /* tOAtB[h */
	    exflag = 0;
	    fwidth = -1;

	    /* ̕oĒׂ */
	    if ((ch = *scanp++) == '\0' || ch == '%')
		goto matchk;

	    /* "*" 邩 */
	    if (ch == '*') {
		exflag |= _P_NOSTORE;
		ch = *scanp++;
	    }

	    /* tB[h */
	    if (_m_isdigit (ch)) {
		n = 0;
		do {
		    n = 10 * n + DEDIGIT (ch);
		} while (ch = *scanp++, _m_isdigit (ch));
		fwidth = n;
	    }

	    /* hlL ̃TCYw蕶 */
	    if (ch == 'h') {
		exflag |= _P_SHRTINT;
		ch = *scanp++;
	    }
	    else if (ch == 'l') {
		exflag |= _P_LONGINT | _P_NDOUBLE;
		ch = *scanp++;
	    }
	    else if (ch == 'L') {
		exflag |= _P_LLNGINT | _P_LONGDBL;
		ch = *scanp++;
	    }
	    else if (ch == '\0')
		goto bailout;

	    /* c,n,[ ȊO͋󔒂XLbv */
	    if (ch != 'c' && ch != 'n' && ch != '[') {
		for (;;) {
		    if ((got = FGETC (fp)) == EOF) {
			eof = 1;
			break;
		    }
		    if (_m_isspace (got) == 0) {
			UNGETC (got, fp);
			break;
		    }
		}
	    }

	    /* 1  case */
	    switch (ch) {

	    /*
	    ** ln...
	    */
	    case 'D':
		exflag |= _P_LONGINT;
	    case 'd':
		base = 10;
		goto snumber;

	    case 'I':
		exflag |= _P_LONGINT;
	    case 'i':
		base = 0;
		goto snumber;

	    case 'o':
		base = 8;
		goto unumber;

	    case 'U':
	    case 'Z':
		exflag |= _P_LONGINT;
	    case 'u':
		base = 10;
		goto unumber;

	    case 'X':
	    case 'x':
	    case 'p':
		base = 16;

	    unumber:

		/* unsigned tOݒ */
		exflag |= _P_UNSIGND;

	    snumber:

		/* |C^ */
		ptr = buffer;

		/* width  -1 Ȃ 512  */
		if (fwidth < 0)
		    fwidth = sizeof (buffer);

		/*  */
		if ((got = FGETC (fp)) == '-' || got == '+') {
		    *ptr++ = got;
		    if (--fwidth <= 0)
			goto intconv;
		    got = FGETC (fp);
		}

		/* ɉď */
		if (got == '0') {
		    *ptr++ = got;
		    if (--fwidth <= 0)
			goto intconv;
		    got = FGETC (fp);
		    if ((got == 'x' || got == 'X') && (base == 0 || base == 16)) {
			base = 16;
			*ptr++ = got;
			if (--fwidth <= 0)
			    goto intconv;
			got = FGETC (fp);
		    }
		    else if (base == 0)
			base = 8;
		}
		else if (base == 0)
		    base = 10;

		/* `FbNp̃CfbNX߂ */
		cmlen = (base == 16) ? 10 + 6 + 6 : base;

		/* KvȐRs[ */
		for (;;) {
		    if (got == EOF) {
			eof = 1;
			break;
		    }
		    if (memchr (m, got, cmlen) == 0) {
			UNGETC (got, fp);
			break;
		    }
		    *ptr++ = got;
		    if (--fwidth <= 0)
			break;
		    got = FGETC (fp);
		}

	    intconv:

		/* NULL ^[~l[g */
		*ptr = '\0';

		/* XgAȂꍇ͂ŏI */
		if (exflag & _P_NOSTORE)
		    break;

		/* 󕶎Ȃ΃G[ */
		if (ptr == buffer)
		    goto bailout;

		/* unsigned ϊ */
		if (exflag & _P_UNSIGND) {

		    if (exflag & _P_LLNGINT) {
			*va_arg (ap, unsigned long long *) = strtoull(buffer, 0, base);
		    }
		    else {
		    /* lɕϊ */
		    uval = strtoul (buffer, 0, base);

		    /* XgA */
		    if (exflag & _P_LONGINT)
			*va_arg (ap, unsigned long *) = uval;
		    else if (exflag & _P_SHRTINT)
			*va_arg (ap, unsigned short *) = uval;
		    else
			*va_arg (ap, unsigned int *) = uval;
		    }
		}

		/* signed ϊ */
		else {

		    if (exflag & _P_LLNGINT) {
			*va_arg (ap, long long *) = strtoll(buffer, 0, base);
		    }
		    else {
		    /* lɕϊ */
		    val = strtol (buffer, 0, base);

		    /* XgA */
		    if (exflag & _P_LONGINT)
			*va_arg (ap, long *) = val;
		    else if (exflag & _P_SHRTINT)
			*va_arg (ap, short *) = val;
		    else
			*va_arg (ap, int *) = val;
		    }
		}

		/* I */
		break;

	    /*
	    ** _n...
	    */
	    case 'E':
	    case 'G':
	    case 'e':
	    case 'f':
	    case 'g':

		/* |C^ */
		ptr = buffer;
		gotdig = 0;

		/* width  -1 Ȃ 512  */
		if (fwidth < 0)
		    fwidth = sizeof (buffer);

		/*  */
		if ((got = FGETC (fp)) == '-' || got == '+') {
		    *ptr++ = got;
		    if (--fwidth <= 0)
			goto floatconv;
		    got = FGETC (fp);
		}

		/*  */
		while (_m_isdigit (got)) {
		    *ptr++ = got;
		    gotdig = 1;
		    if (--fwidth <= 0)
			goto floatconv;
		    got = FGETC (fp);
		}

		/* _ */
		if (got == '.') {
		    *ptr++ = got;
		    if (--fwidth <= 0)
			goto floatconv;
		    got = FGETC (fp);
		}

		/*  */
		while (_m_isdigit (got)) {
		    *ptr++ = got;
		    gotdig = 1;
		    if (--fwidth <= 0)
			goto floatconv;
		    got = FGETC (fp);
		}

		/* e,E ȂΎw荞 */
		if (gotdig && (got == 'e' || got == 'E')) {

		    /* w */
		    *ptr++ = got;
		    if (--fwidth <= 0)
			goto floatconv;
		    got = FGETC (fp);

		    /* w */
		    if (got == '+' || got == '-') {
			*ptr++ = got;
			if (--fwidth <= 0)
			    goto floatconv;
			got = FGETC (fp);
		    }

		    /* wȂ΃G[ */
		    if (_m_isdigit (got) == 0)
			goto bailout;

		    /* w */
		    do {
			*ptr++ = got;
			if (--fwidth <= 0)
			    goto floatconv;
			got = FGETC (fp);
		    } while (_m_isdigit (got));
		}

		/* ǂ݂߂ */
		UNGETC (got, fp);

	    floatconv:

		/* NULL ^[~l[g */
		*ptr = '\0';

		/* 𓾂Ȃꍇ͏I */
		if (gotdig == 0)
		    goto bailout;

		/* XgAȂꍇ͂ŏI */
		if (exflag & _P_NOSTORE)
		    break;

		/* lɕϊ */
		dval = strtod (buffer, 0);

		if (exflag & _P_NDOUBLE)
		    *va_arg (ap, double *) = dval;
		else if (exflag & _P_LONGDBL)
		    *va_arg (ap, long double *) = dval;
		else
		    *va_arg (ap, float *) = dval;

		/* I */
		break;

	    /*
	    ** ...
	    */
	    case 'c':

		/* width  -1 Ȃ 1  */
		if (fwidth < 0)
		    fwidth = 1;

		/* i[̃|C^ */
		stb = ptr = (exflag & _P_NOSTORE) ? buffer : va_arg (ap, char *);

		/* tB[hǂݍ */
		while (fwidth--) {
		    if ((got = FGETC (fp)) == EOF) {
			eof = 1;
			break;
		    }
		    *ptr++ = got;
		}

		/* ܂ǂݍ܂Ȃꍇ̓G[ */
		if (fwidth >= 0 && ptr == stb)
		    goto bailout;

		/* I */
		break;

	    /*
	    ** ...
	    */
	    case 's':

		/* width  -1 Ȃ 512  */
		if (fwidth < 0)
		    fwidth = sizeof (buffer);

		/* i[̃|C^ */
		stb = ptr = (exflag & _P_NOSTORE) ? buffer : va_arg (ap, char *);

		/* tB[hǂݍ */
		while (fwidth--) {
		    if ((got = FGETC (fp)) == EOF) {
			eof = 1;
			break;
		    }
		    if (_m_isspace (got)) {
			UNGETC (got, fp);
			break;
		    }
		    *ptr++ = got;
		}

		/* AsɊւ炸I[ł */
		*ptr = '\0';

		/* ܂ǂݍ܂Ȃꍇ̓G[ */
		if (fwidth >= 0 && ptr == stb)
		    goto bailout;

		/* Ȃɂǂݍ񂾏ꍇ͑s */
		break;

	    /*
	    ** IZbg...
	    */
	    case '[':

		/* tB[h */
		if (fwidth < 0)
		    fwidth = sizeof (buffer);

		/* |C^o */
		stb = ptr = (exflag & _P_NOSTORE)
		    ? buffer : va_arg (ap, char *);

		/* ^ ̏ */
		if (*scanp == '^') {
		    scanp++;
		    reverse = 1;
		}
		else
		    reverse = 0;

		/*  ]  ] Ƃ݂͂ȂȂ */
		end = (unsigned char *)
		    strchr ((char *) (*scanp == ']' ? scanp + 1 : scanp), ']');
		if (end == 0)
		    goto bailout;

		/* LN^Zbg̒߂ */
		cmlen = end - scanp;

		/* 荞 */
		while (fwidth--) {
		    if ((got = FGETC (fp)) == EOF) {
			eof = 1;
			break;
		    }
		    if ((reverse == 0 && scanchr (scanp, got, cmlen) == 0) ||
			(reverse && scanchr (scanp, got, cmlen))) {
			UNGETC (got, fp);
			break;
		    }
		    *ptr++ = got;
		}
		*ptr = '\0';

		/* 󕶎ȂΏI */
		if (fwidth >= 0 && ptr == stb)
		    goto bailout;

		/* ] ̎Ɉړ */
		scanp = end + 1;
		break;

	    /*
	    ** ȊO...
	    */
	    case 'n':
		if ((exflag & _P_NOSTORE) == 0)
		    *va_arg (ap, int *) = readed;
		exflag |= _P_NOSTORE;
		break;

	    /*
	    ** ȊO͂̕
	    */
	    default:
		goto matchk;

	    }

	    /* }b`AڐZ */
	    if ((exflag & _P_NOSTORE) == 0)
		nmatch++;

	}

	/* 󔒕Ȃ΃XLbv */
	else if (_m_isspace (ch)) {

	    /* tH[}bg̋󔒕܂XLbv */
	    while (_m_isspace (*scanp))
		scanp++;

	    /* Xg[̋󔒕SăXLbv */
	    while ((got = FGETC (fp)) != EOF) {
		if (_m_isspace (got) == 0) {
		    UNGETC (got, fp);
		    break;
		}
	    }

	    /* IȂ ... */
	    if (got == EOF)
		break;

	}

	/* ȊOȂ΃}b`邩ǂ`FbN */
	else {

	  matchk:

	    /* 1 oă`FbN */
	    if ((got = FGETC (fp)) != ch) {
		UNGETC (got, fp);
		return nmatch;
	    }

	}

    }

  bailout:

    /* ڐԂ */
    return (eof && (nmatch == 0)) ? EOF : nmatch;
}
