/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * high speed patched by 씎Y(oo), HGG00736@niftyserve.or.jp
 */

/* System headers */
#include "sys/xstdlib.h"

/*
** {֐͕_{xɕϊĂ當ɂ邽߁AxIɂ
** {xɊi[ł錅܂łƂłȂBčōx
** 18łB
*/

/*
 *	w -308 ~ +308 Ȃ̂ 32*10(64+20=84)  16*20(32+40=72) ̕
 *	e[uTCYł(1994/12/16 by oo)
 */
#ifdef	DTOS18_LIBC
#define	TAB1_SIZE	32
#define	TAB2_SHIFT	5
#else	/*!DTOS18_LIBC*/
#define	TAB1_SIZE	16
#define	TAB2_SHIFT	4
#endif
#define	TAB1_MASK	(TAB1_SIZE-1)

/* File scope variables */
static double _pos1[TAB1_SIZE] = {
    1.0e+17,					/* + 0 */
    1.0e+18,					/* + 1 */
    1.0e+19,					/* + 2 */
    1.0e+20,					/* + 3 */
    1.0e+21,					/* + 4 */
    1.0e+22,					/* + 5 */
    1.0e+23,					/* + 6 */
    1.0e+24,					/* + 7 */
    1.0e+25,					/* + 8 */
    1.0e+26,					/* + 9 */
    1.0e+27,					/* +10 */
    1.0e+28,					/* +11 */
    1.0e+29,					/* +12 */
    1.0e+30,					/* +13 */
    1.0e+31,					/* +14 */
    1.0e+32,					/* +15 */
#ifdef	DTOS18_LIBC	/* e[uTCY} 1994/12/16 by oo */
    1.0e+33,					/* +16 */
    1.0e+34,					/* +17 */
    1.0e+35,					/* +18 */
    1.0e+36,					/* +19 */
    1.0e+37,					/* +20 */
    1.0e+38,					/* +21 */
    1.0e+39,					/* +22 */
    1.0e+40,					/* +23 */
    1.0e+41,					/* +24 */
    1.0e+42,					/* +25 */
    1.0e+43,					/* +26 */
    1.0e+44,					/* +27 */
    1.0e+45,					/* +28 */
    1.0e+46,					/* +29 */
    1.0e+47,					/* +30 */
    1.0e+48,					/* +31 */
#endif
};

/* File scope variables */
static double _neg1[TAB1_SIZE] = {
    1.0e+17,					/* - 0 */
    1.0e+16,					/* - 1 */
    1.0e+15,					/* - 2 */
    1.0e+14,					/* - 3 */
    1.0e+13,					/* - 4 */
    1.0e+12,					/* - 5 */
    1.0e+11,					/* - 6 */
    1.0e+10,					/* - 7 */
    1.0e+9,					/* - 8 */
    1.0e+8,					/* - 9 */
    1.0e+7,					/* -10 */
    1.0e+6,					/* -11 */
    1.0e+5,					/* -12 */
    1.0e+4,					/* -13 */
    1.0e+3,					/* -14 */
    1.0e+2,					/* -15 */
#ifdef	DTOS18_LIBC	/* e[uTCY} 1994/12/16 by oo */
    1.0e+1,					/* -16 */
    1.0e+0,					/* -17 */
    1.0e-1,					/* -18 */
    1.0e-2,					/* -19 */
    1.0e-3,					/* -20 */
    1.0e-4,					/* -21 */
    1.0e-5,					/* -22 */
    1.0e-6,					/* -23 */
    1.0e-7,					/* -24 */
    1.0e-8,					/* -25 */
    1.0e-9,					/* -26 */
    1.0e-10,					/* -27 */
    1.0e-11,					/* -28 */
    1.0e-12,					/* -29 */
    1.0e-13,					/* -30 */
    1.0e-14,					/* -31 */
#endif
};

/* File scope variables */
static double _pos2[] = {
#ifdef	DTOS18_LIBC	/* e[uTCY} 1994/12/16 by oo */
    1.0e+0,						/* 000 */
    1.0e+32,					/* 001 */
    1.0e+64,					/* 010 */
    1.0e+96,					/* 011 */
    1.0e+128,					/* 100 */
    1.0e+160,					/* 101 */
    1.0e+192,					/* 110 */
    1.0e+224,					/* 111 */
    1.0e+256,					/* added by oo */
    1.0e+288,					/* added by oo */
#else
    1.0e+0,						/*  0 */
    1.0e+16,					/*  1 */
    1.0e+32,					/*  2 */
    1.0e+48,					/*  3 */
    1.0e+64,					/*  4 */
    1.0e+80,					/*  5 */
    1.0e+96,					/*  6 */
    1.0e+112,					/*  7 */
    1.0e+128,					/*  8 */
    1.0e+144,					/*  9 */
    1.0e+160,					/* 10 */
    1.0e+176,					/* 11 */
    1.0e+192,					/* 12 */
    1.0e+208,					/* 13 */
    1.0e+224,					/* 14 */
    1.0e+240,					/* 15 */
    1.0e+256,					/* 16 */
    1.0e+272,					/* 17 */
    1.0e+288,					/* 18 */
    1.0e+304,					/* 19 */
#endif
};

/* File scope variables */
static double _neg2[] = {
#if	DTOS18_LIBC	/* e[uTCY} 1994/12/16 by oo */
    1.0e-0,						/* 000 */
    1.0e-32,					/* 001 */
    1.0e-64,					/* 010 */
    1.0e-96,					/* 011 */
    1.0e-128,					/* 100 */
    1.0e-160,					/* 101 */
    1.0e-192,					/* 110 */
    1.0e-224,					/* 111 */
    1.0e-256,					/* added by oo */
    1.0e-288,					/* added by oo */
#else
    1.0e-0,						/*  0 */
    1.0e-16,					/*  1 */
    1.0e-32,					/*  2 */
    1.0e-48,					/*  3 */
    1.0e-64,					/*  4 */
    1.0e-80,					/*  5 */
    1.0e-96,					/*  6 */
    1.0e-112,					/*  7 */
    1.0e-128,					/*  8 */
    1.0e-144,					/*  9 */
    1.0e-160,					/* 10 */
    1.0e-176,					/* 11 */
    1.0e-192,					/* 12 */
    1.0e-208,					/* 13 */
    1.0e-224,					/* 14 */
    1.0e-240,					/* 15 */
    1.0e-256,					/* 16 */
    1.0e-272,					/* 17 */
    1.0e-288,					/* 18 */
    1.0e-304,					/* 19 */
#endif
};

/* File scope functions */
static int _cmpd (double x, double y)
{
    unsigned long vx, vy, rc;
    unsigned long *x_ptr = (unsigned long *) &x;
    unsigned long *y_ptr = (unsigned long *) &y;

    /* x̎wrbgo */
    vx = x_ptr[0] & 0x7FF00000;

    /* y̎wrbgo */
    vy = y_ptr[0] & 0x7FF00000;

    /* wrbgŔf */
    if ((rc = vy - vx) != 0)
	return rc;

    /* x̗L̏ʃrbgo */
    vx = x_ptr[0] & 0x000FFFFF;

    /* y̗L̏ʃrbgo */
    vy = y_ptr[0] & 0x000FFFFF;

    /* ʃrbgŔf */
    if ((rc = vy - vx) != 0)
	return rc;

    /* x̗L̉ʃrbgo */
    vx = x_ptr[1];

    /* y̗L̉ʃrbgo */
    vy = y_ptr[1];

    /* ŏIf */
    return vy - vx;
}

/* Functions */
void _dtos18 (double x, int *decpt, int *sign, char *buffer)
{
    short e2;
    int e, n;

    /* vZ */
    *sign = ((unsigned char *) &x)[0] & 0x80U;

    /* 2̎w߂(oCAXȂ̏) */
    e2 = (((unsigned short *) &x)[0] & 0x7FF0U) >> 4;

    /* w0̏ꍇ́}0.0`FbN */
    if (e2 == 0) {

	unsigned long hi = ((unsigned long *) &x)[0] & 0xFFFFF;
	unsigned long lo = ((unsigned long *) &x)[1];

	/* LS0ǂ */
	if (hi == 0 && lo == 0) {

	    /* ݒ */
	    buffer[0] = '0';

	    /* NULݒ */
	    buffer[1] = '\0';

	    /* _ʒuvZ */
	    *decpt = 1;

	    /* m */
	    return;

	}

    }

    /* 2̎w10̎wTZ (approx. log10(2)) */
    e = ((int) ((e2 - 1023) * 77)) >> 8;

    /* w̏ꍇ */
    if (e >= 0) {

	/* w32菬ꍇ̓e[u1 */
	if (e < TAB1_SIZE)
	    x *= _neg1[e];

	/* w32傫ꍇ̓e[u1,2 */
	else
	    x *= _neg1[e & TAB1_MASK] * _neg2[e >> TAB2_SHIFT];

    }

    /* w̏ꍇ */
    else {

	/* ΒlvZ */
	n = -e;

	/* Βl32菬ꍇ̓e[u1 */
	if (n < TAB1_SIZE)
	    x *= _pos1[n];

	/* Βl32傫ꍇ̓e[u1,2 */
	else {
	    x *= _pos1[n & TAB1_MASK];
	    x *= _pos2[n >> TAB2_SHIFT];
	}
    }

    /* XP[Oꍇ͖߂ */
    if (_cmpd (1.0e+18, x) >= 0) {
	e++;
	x *= 1.0e-1;
    }

    /* XP[OȂꍇ͒ǉ */
    else if (_cmpd (1.0e+17, x) < 0) {
	e--;
	x *= 1.0e+1;
    }

    /* _ʒuvZ */
    *decpt = e + 1;

    /* ɕϊ */
    _ulltoda (buffer, (unsigned long long) x);
}
