*
*	div10di.s: part of libhdi(high speed double integer library)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
value	ds.l	1
valueH	ds.l	1

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif

*---------------------------------------
~result	.reg	d0
~value	.reg	d1
~ten	.reg	d2
*---------------------------------------

___div10si::
.if	MPU>=68020
	move.l	value(sp),~result
	divs.l	#10,~result
.else
	move.l	value(sp),~value
	bpl.s	udiv10si_0
	neg.l	~value
	bsr	udiv10si_0
	neg.l	~result
.endif
	rts

.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
___udiv10si::
.if	MPU>=68020
	move.l	value(sp),~result
	divu.l	#10,~result
.else
	move.l	value(sp),~value
	moveq.l	#0,~result
udiv10si_0:
	cmp.l	#655360,~value
	blo.s	udiv10si_divuw

	lsr.l	#4,~value	* value/16	(>>4)
	move.l	~value,~result
	lsr.l	#1,~value	* value/32	(>>5)
	add.l	~value,~result
	lsr.l	#3,~value	* value/256	(>>8)
	add.l	~value,~result
	lsr.l	#1,~value	* value/512	(>>9)
	add.l	~value,~result
	lsr.l	#3,~value	* value/4096	(>>12)
	add.l	~value,~result
	lsr.l	#1,~value	* value/8192	(>>13)
	add.l	~value,~result
	lsr.l	#3,~value	* value/65536	(>>16)
	add.l	~value,~result

udiv10si_shift_loop:
	lsr.l	#1,~value
	add.l	~value,~result
	lsr.l	#3,~value
	beq.s	udiv10si_end
	add.l	~value,~result
	bra.s	udiv10si_shift_loop

udiv10si_divuw:
	moveq.l	#10,~ten
	cmp.l	~ten,~value
	bhs.s	udiv10si_divuw_exec
udiv10si_zero:
	moveq.l	#0,~result
	rts

udiv10si_divuw_exec:
	divu.w	~ten,~value
	move.w	~value,~result
udiv10si_end:
.endif
	rts

*---------------------------------------
~resL	.reg	d0
~valL	.reg	d1
~valH	.reg	d2
~resH	.reg	d3
~saved3	.reg	a0
*---------------------------------------

.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
___div10di::
	move.l	value(sp),~valL
	move.l	valueH(sp),~valH
	bne.s	div10di_check_sign
div10di_si_plus:
.if	MPU>=68020
	move.l	~valL,~resL
	divu.l	#10,~resL
.else
	bsr	udiv10si_0
.endif
	moveq.l	#0,d1
	rts

div10di_check_sign
	bpl.s	udiv10di_0
	neg.l	~valL
	negx.l	~valH
	tst.l	~valH
	bne.s	div10di_di_minus
div10di_si_minus:
.if	MPU>=68020
	move.l	~valL,~resL
	divu.l	#10,~resL
.else
	bsr	udiv10si_0
.endif
	neg.l	~resL
	moveq.l	#-1,d1
	rts

div10di_di_minus:
	bsr	udiv10di_0
	neg.l	~resL
	negx.l	d1
	rts

.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
___udiv10di::
	move.l	value(sp),~valL
	move.l	valueH(sp),~valH
	beq.s	div10di_si_plus
udiv10di_0:
	move.l	d3,~saved3
	moveq.l	#0,~resL
	moveq.l	#0,~resH

	lsr.l	#1,~valH
	roxr.l	#1,~valL
udiv10di_shift_loop:
	lsr.l	#1,~valH
	roxr.l	#1,~valL
	lsr.l	#1,~valH
	roxr.l	#1,~valL
	lsr.l	#1,~valH
	beq.s	udiv10di_shift_loop1
	roxr.l	#1,~valL
	add.l	~valL,~resL
	addx.l	~valH,~resH

	lsr.l	#1,~valH
	roxr.l	#1,~valL
	add.l	~valL,~resL
	addx.l	~valH,~resH
	bra.s	udiv10di_shift_loop

udiv10di_shift_loop1:
	roxr.l	#1,~valL
	add.l	~valL,~resL
	addx.l	~valH,~resH

udiv10di_shift_loop2:
	lsr.l	#1,~valL
	add.l	~valL,~resL
	addx.l	~valH,~resH

	lsr.l	#3,~valL
	beq.s	udiv10di_end
	add.l	~valL,~resL
	addx.l	~valH,~resH
	bra.s	udiv10di_shift_loop2

udiv10di_end:
	move.l	~resH,d1
	move.l	~saved3,d3
	rts
	.end
