/*
 *	testdir/cmp0.c: part of libhdi(high speed double integer library)
 *	Copyright  1994  씎Y(oo) HGG00736@niftyserve.or.jp
 */
#include	<stdio.h>
#include	<time.h>

#ifndef	MPU
#define	MPU	68000
#endif

#if		MPU>=68040
#define	COUNT	500000
#elif	MPU>=68030
#define	COUNT	100000
#else
#define	COUNT	10000
#endif

volatile long	cmpdi;

extern long __cmpdi2(long long, long long);
extern long __cmp0di(long long);

void	main(void)
{
	long	i;
	long long	value = 1LL;
	clock_t	start, stop;

	setvbuf(stdout, NULL, _IONBF, 0);
	for (;;) {
		start = clock();
		for (i = COUNT; --i >= 0;) {
			cmpdi = __cmpdi2(value, 0LL);
		}
		stop = clock();
		printf("%20Ld==0:%6ld, ", value, stop - start);

		start = clock();
		for (i = COUNT; --i >= 0;) {
			cmpdi = __cmp0di(value);
		}
		stop = clock();
		printf("__cmp0di(%20Ld):%6ld\n", value, stop - start);

		if (value == -1LL) {
			break;
		}
		else if (value > 0LL) {
			value <<= 1LL;
		}
		else {
			value >>= 1LL;
		}
	}
}
