/*
 *	testdir/div10.c: part of libhdi(high speed double integer library)
 *	Copyright  1994  씎Y(oo) HGG00736@niftyserve.or.jp
 */
#include	<stdio.h>
#include	<time.h>

#ifndef	MPU
#define	MPU	68000
#endif
#if	MPU>=68030
#define	COUNT	100000
#else
#define	COUNT	10000
#endif

volatile long long	divdi;

extern long long __divdi3(long long, long long);
extern long long __div10di(long long);

void	main(void)
{
	long	i;
	long long	value = 1LL;
	long long	r1, r2;
	clock_t	start, stop;

	setvbuf(stdout, NULL, _IONBF, 0);
	for (;;) {
		start = clock();
		for (i = COUNT; --i >= 0;) {
			divdi = __divdi3(value, 10LL);
		}
		stop = clock();
		printf("%20Ld/10:%6ld, ", value, stop - start);
		r1 = divdi;

		start = clock();
		for (i = COUNT; --i >= 0;) {
			divdi = __div10di(value);
		}
		stop = clock();
		printf("__div10di(%20Ld):%6ld\n", value, stop - start);
		r2 = divdi;

		if (r1 != r2) {
			fprintf(stderr, "%20Ld, %20Ld\n", r1, r2);
			break;
		}
		if (value == -1LL) {
			break;
		}
		else if (value > 0LL) {
			value <<= 1LL;
		}
		else {
			value >>= 1LL;
		}
	}
}
