/*
 *	testdir/tprnt.c: part of libhdi(high speed double integer library)
 *	Copyright  1994  씎Y(oo) HGG00736@niftyserve.or.jp
 */
#include	<stdio.h>
#include	<limits.h>
#include	<time.h>
#if	0
#include	<float.h>
#else
/* libc-1.1.32  double ϊ̃oO΍ */
#define DBL_MIN          2.2250738585072014e-250
#define DBL_MAX          1.7976931348623157e+250
#endif

#ifndef	MPU
#define	MPU	68000
#endif
#if	MPU>=68030
#define	COUNT	10000
#else
#define	COUNT	1000
#endif


void	main(void)
{
	long	i;
	unsigned long svalue = ULONG_MAX;
	unsigned long long	value = ULONGLONG_MAX;
	char	buff[128];
	clock_t	start, stop;

	setvbuf(stdout, NULL, _IONBF, 0);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%lx", 0x100);
	}
	stop = clock();
	printf("sprintf(\"%%lx\",                0x%s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%lx", svalue);
	}
	stop = clock();
	printf("sprintf(\"%%lx\",           0x%s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%lu", 100);
	}
	stop = clock();
	printf("sprintf(\"%%lu\",                  %s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%lu", svalue);
	}
	stop = clock();
	printf("sprintf(\"%%lu\",           %s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%lu", 999999999);
	}
	stop = clock();
	printf("sprintf(\"%%lu\",            %s):%4ld\n", buff, stop - start);


	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%Lx", 0x100ULL);
	}
	stop = clock();
	printf("sprintf(\"%%Lx\",                0x%s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%Lx", value);
	}
	stop = clock();
	printf("sprintf(\"%%Lx\",   0x%s):%4ld\n", buff, stop - start);


	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%Lu", 100ULL);
	}
	stop = clock();
	printf("sprintf(\"%%Lu\",                  %s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%Lu", value);
	}
	stop = clock();
	printf("sprintf(\"%%Lu\", %s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%Lu", 9999999999999999999ULL);
	}
	stop = clock();
	printf("sprintf(\"%%Lu\",  %s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%Lu", 1000000000000000001ULL);
	}
	stop = clock();
	printf("sprintf(\"%%Lu\",  %s):%4ld\n", buff, stop - start);


	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%.12e", DBL_MIN);
	}
	stop = clock();
	printf("sprintf(\"%%e\" ,  %s):%4ld\n", buff, stop - start);

	start = clock();
	for (i = COUNT; --i >= 0;) {
		sprintf(buff, "%.12e", DBL_MAX);
	}
	stop = clock();
	printf("sprintf(\"%%e\" ,  %s):%4ld\n", buff, stop - start);
}
